<?php

/******************************************************************************
 *
 *	PROJECT: Flynax Classifieds Software
 *	VERSION: 4.X
 *	LICENSE: FL0M2SG681CQ - http://www.flynax.com/license-agreement.html
 *	PRODUCT: Pets Classifieds
 *	DOMAIN: pupsnshop.com
 *	FILE: POST.GATEWAY.PHP
 *
 *	The software is a commercial product delivered under single, non-exclusive, 
 *	non-transferable license for one domain or IP address. Therefore distribution, 
 *	sale or transfer of the file in whole or in part without permission of Flynax 
 *	respective owners is considered to be illegal and breach of Flynax License End 
 *	User Agreement. 
 *
 *	You are not allowed to remove this information from the file without permission
 *	of Flynax respective owners.
 *
 *	Flynax Classifieds Software 2014 |  All copyrights reserved. 
 *
 *	http://www.flynax.com/
 *
 ******************************************************************************/
 
require_once( '../../../includes/config.inc.php' );

/* system controller */
require_once( RL_INC . 'control.inc.php' );

$reefless->loadClass( 'Cache' );

/* load system configurations */
$config = $rlConfig->allConfig();

if ( !empty( $_GET['item_number'] ) )
{
	$items = explode( '|', base64_decode( urldecode( $_GET['item_number'] ) ) );
	$plan_id = $items[0];
	$item_id = $items[1];
	$account_id = $items[2];
	$total = $items[3];
	$callback_class = $items[4];
	$callback_method = $items[5];
	$cancel_url = $items[6];
	$success_url = $items[7];
	$lang_code = $items[8];
	$plugin = $items[9]; // $plugin from v4.0.2
	
	$signature = md5( $GLOBALS['config']['bitpay_api'] . 1 . $reference . $price . $GLOBALS['config']['bitpay_currency'] );

	define( 'RL_LANG_CODE', $lang_code );

	$seo_base = RL_URL_HOME;
	$seo_base .= $lang_code == $config['lang'] ? '' : $lang_code . '/';

	$lang = $rlLang -> getLangBySide( 'frontEnd', RL_LANG_CODE );
	$GLOBALS['lang'] = $lang;

	if ( empty( $item_id ) || empty( $total ) )
	{
		$errors = true;
	}

	if($signature != trim($_GET['s']))
	{
		$errors = true;
	}
	
	$trans_id = $_POST['trans_id']; 
	$id_get = $_POST['id_get'];
	
	if( $GLOBALS['config']['bitpay_test_mode'] ) {
		$api = 'adxcv-zzadq-polkjsad-opp13opoz-1sdf455aadzmck1244567';
		$url = 'https://bitpay.ir/payment-test/gateway-result-second'; 
	}
	else {
		$api = $GLOBALS['config']['bitpay_api'];
		$url = 'https://bitpay.ir/payment/gateway-result-second'; 
	}
	
	$ch = curl_init();     
	curl_setopt($ch,CURLOPT_URL,$url);     
	curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
	$res = curl_exec($ch);
	curl_close($ch); 

	switch( $res ) {
		case '-1' :   
			$errors[] = 'بیت پی : کد api ارسالی با کد api ثبت شده در بیت پی سازگار نیست.';
			break;
		case '-2' :  
			$errors[] = 'بیت پی : شماره تراکنش ارسالی نامعتبر است.';
			break;    
		case '-3' : 
			$errors[] = 'بیت پی : id_get ارسالی نامعتبر می باشد.';
			break;
		case '-4' :
			$errors[] = 'بیت پی : چنین تراکنشی وجود ندارد و یا قبلا با موفقیت به اتمام رسیده است. همچنین امکان دارد عملیات پرداخت توسط کاربر لغو شده باشد.';
			break;
		case '1' :
			$errors = false;
			break;
	}

	if ( ! $errors ) 
	{
		$reefless -> loadClass( str_replace( 'rl', '', $callback_class ), null, $plugin );
		$$callback_class -> $callback_method( $item_id, $plan_id, $account_id, $txn_id, 'bitpay', $total );

		$reefless -> redirect( false, str_replace( '&amp;', '&', $success_url ) );
	}   
	else
	{
		$reefless -> redirect( false, str_replace( '&amp;', '&', $cancel_url ) );
	}
}
